// progn01 zo.14/5/06

#include <avr/interrupt.h>
#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <inttypes.h>
#include <avr/signal.h>

#define F_CPU 8000000
#define baudrate 9600

long int epjaar;
long double epjuldag;
long double drag;
long double inclin;
long double epraan;
long double eccen;
long double epargofp;
long double epma;
long double meanmot;
long int eprevol;

long double stnlat;
long double stnlong;
int stnalt;

long double  TP=2*3.141592653589793,deg2rad=3.141592653589793/180.0,R0=6378.16,FF=1/298.16;

long double	c, ms, t1, t2, t3, ew, e, n, si, co, ra, gh,
      lh, gm, de, se, gs, dc, yr;

long double	faz,fel,age, daynum, sma, range,  av1, av2, n0,
	k2, s1, c1, l8, s9, c9, s8, c8, r9, z9, x9, y9, o, w, q, s0, s2,
	c2, q0, m,  s3, c3, c0, r3, m1, m5, x0, yzero, x1, yone, r,
	z1, g7, s7, c7, x,  y, z, x5, y5, z5, z8, x8, y8, df;
long double a0,a1,a2,a3,a4,a5,ops2,ops;

int sec,min,uur,dag,mnd,osec;
long double buur,bmin,bsec;
long double dn;
int t;
unsigned int bauddiv;

/****************************************************/
/* Current                                          */
/*                                                  */
/****************************************************/
long double Current(void)
{
 sec=sec+1;
 if(sec>59) {sec=0;min=min+1;}
 
 t=(int)(30.55*(mnd+2))-2*((int)(0.1*(mnd+7)))-91;
 
 t=t+dag;
 buur=(long double)(uur/24.0);
 bmin=(long double)(min/1440.0);
 bsec=(long double)(sec/86400.0);
 dn=buur+bmin+bsec+t;
 
 printf("\r\n");
 printf(" TIME : %i:%i:%i\r\n",uur,min,sec);
 printf(" dn : %.8f\r\n",dn);
 
 return dn;
}

/****************************************************/
/* PreCalc                                          */
/*                                                  */
/****************************************************/
void PreCalc(void)
{
	age=daynum-epjuldag;
	yr=epjaar;
	if (yr<=50.0) yr+=100.0;
    t1=yr-1.0;
	df=floor(365.25*(t1-80.0))-floor(t1/100.0)+floor(t1/400.0+0.75)+366.0;
	t1=(df+29218.5)/36525.0;
	t1=t1*(2400.051262+t1*2.581e-5)+6.6460656;
	se=t1/24.0-yr;
	n0=meanmot+age*drag;
	ops=1440.0/n0;ops2=2.0/3.0;
	sma=pow(ops,ops2)*331.25;
	av2=1.0-eccen*eccen;
	av1=sqrt(av2);
    ops=inclin*deg2rad;
	s1=sin(ops);
	c1=cos(ops);
	l8=stnlat*deg2rad;
	s9=sin(l8);
	c9=cos(l8);
	ops=-stnlong*deg2rad;
	s8=sin(ops);
	ops=stnlong*deg2rad;
	c8=cos(ops);
	ops=l8*2.0;
	r9=R0*(1.0+(FF/2.0)*(cos(ops)-1.0))+stnalt/1000.0;
    ops=(1.0-FF)*(1.0-FF)*s9/c9;
    l8=atan(ops);
	z9=r9*sin(l8);
	x9=r9*cos(l8)*c8;
	y9=r9*cos(l8)*s8;
	ops=R0/sma;
	ops=log(ops)*3.5;
	ops=exp(ops);
    k2=ops*9.95/av2*av2;
}

/****************************************************/
/* outterm                                          */
/*                                                  */
/****************************************************/
void outterm(void)
{
  printf(" az = %f\r\n",faz);
  printf(" el = %f\r\n",fel);
}

/****************************************************/
/* Calc : Bereken azimuth en elavation              */
/*                                                  */
/****************************************************/
void Calc(void)
{
	age=daynum-epjuldag;
	ops=epraan-age*k2*c1;
	o=ops*deg2rad;
	s0=sin(o);
	c0=cos(o);
	ops=age*k2*(2.5*c1*c1-0.5)+epargofp;
	w=ops*deg2rad;
	s2=sin(w);
	c2=cos(w);
	a0=c2*c0-s2*s0*c1;
	a1=-s2*c0-c2*s0*c1;
	a2=c2*s0+s2*c0*c1;
	a3=-s2*s0+c2*c0*c1;
	a4=s2*s1;
	a5=c2*s1;
	q0=epma/360.0+eprevol;
	q=n0*age+q0;
	q=q-floor(q);
	m=q*TP;
	ops=m*2.0;
	ops2=eccen*sin(ops)*0.5+sin(m);
	e=ops2*eccen+m;

	do   
	{
	 s3=sin(e);
	 c3=cos(e);
	 ops=eccen*c3;
	 r3=1.0-ops;
	 ops=eccen*s3;
	 m1=e-ops;
	 m5=m1-m;
	 e=e-m5/r3;
	}
	while (fabs(m5)>=1.0e-6);
	
    x0=(c3-eccen)*sma;
	yzero=sma*av1*s3;
	r=sma*r3;
	x1=x0*a0+yzero*a1;
	yone=x0*a2+yzero*a3;
	z1=x0*a4+yzero*a5;
	g7=daynum*1.0027379093+se;
	g7=(g7-floor(g7))*TP;
	s7=-sin(g7);
	c7=cos(g7);
	x=x1*c7-yone*s7;
	y=x1*s7+yone*c7;
	z=z1;
	x5=x-x9;
	y5=y-y9;
	z5=z-z9;
	range=x5*x5+y5*y5+z5*z5;
	z8=x5*c8*c9+y5*s8*c9+z5*s9;
	x8=-x5*c8*s9-y5*s8*s9+z5*c9;
	y8=y5*c8-x5*s8;
	
	ops=range-z8*z8;
	ops=sqrt(ops);
	ops=z8/ops;
	fel=atan(ops)/deg2rad;
	
	ops=y8/x8;
	faz=atan(ops)/deg2rad;
	
	if (x8<0.0) faz=faz+180.0;
	if (faz<0.0) faz=faz+360.0;
	
	if(fel<0.0) fel=0.0;
	
	if(sec==osec) return;
	osec=sec;
	outterm();
	
}

/****************************************************/
/* Transmit byte to uart                            */
/*                                                  */
/****************************************************/
int TxChar(unsigned char c)
{
    while (!(UCSRA & (_BV(UDRE))));
    UDR = c;
    return 0;
}

/****************************************************/
/* MAIN                                             */
/*                                                  */
/****************************************************/
int main(void)
{
    UCSRB |= _BV(TXEN);  
    UCSRC |= _BV(URSEL)|_BV(UCSZ0)|_BV(UCSZ1);
	
	bauddiv = ((F_CPU+(baudrate*8L))/(baudrate*16L)-1);
	outb(UBRRL, bauddiv);
	outb(UBRRH, bauddiv>>8);
	
    fdevopen(TxChar,NULL,0);
	
    stnlat=50.967;
    stnlong=-5.167;
    stnalt=25;

    epjaar=6;epjuldag=132.37822161;drag=0.00000030;
	inclin=98.7285;epraan=125.8159;eccen=0.0012507;epargofp=188.3721;
	epma=171.7279;meanmot=14.25488690;eprevol=77914;
	
    dag=14;mnd=5;
    uur=5;min=26;sec=50;
	
	daynum=Current();
	PreCalc();
	
    for (;;)          /* Endless loop   */
    {
	  daynum=Current();
      Calc();
	}	

return(0);
}
